from django.test import TestCase
from django.contrib.auth.models import User

from flowrepo.models import Report, FlowItem
from flowrepo.forms import FlowItemForm

__all__ = ['FormTest']


class ReportForm(FlowItemForm):
    
    class Meta:
        model = Report


class FormTest(TestCase):
    
    def setUp(self):
        self.user = User.objects.create_user('testuser', 'test@testuser.com', 'testuser')
    
    def testAdd(self):
        f = ReportForm(user = self.user,
                       data = {'name': 'A test report',
                               'body': 'this is the body',
                               'tags': 'test report flow',
                               'visibility': 3})
        valid = f.is_valid()
        self.assertTrue(valid)
        r = f.save().flowitem()
        self.assertTrue(isinstance(r,FlowItem))
        self.assertEqual(r.tags,'test report flow')
        